<?php
/*
	Copyright(c) 2008 iTD Inc. All Rights Reserved.
 	http://www.itd-inc.jp/
*/

require_once (LIB_PATH.'/common/unitCommon.php');
require_once (LIB_PATH.'/common/imgmngrDB.php');
/*
--詳細データ格納テーブル（公開情報）
CREATE TABLE extunit_instatl (
	pageu_code			integer,				--ユニット配列順序における登録番号
	dispflg				integer default 10,		--表示件数
	bg_color			smallint default 0,		--背景色　0：なし　1：あり
	bdr_type			smallint default 0,		--囲み線　0：なし　1：実線　2：点線
	btm_padding			smallint default 2,		--下部余白　0:なし　1：狭　2：標準　3：広
	link_type			smallint default 0,		--リンク先　0:投稿　1：ユーザー
	align_type			smallint default 0,		--寄せ方向　現在未使用
	access_token		text,					--facebook api アクセストークン
	insta_id			text,					--Instagram Business ID
	extra_class			text,					--ユーザー追加クラス(2021-06-09)
	anchor_text			text,					--アンカーテキスト(2021-06-09)
	animatecsshelp		text,					--アニメーションクラス(2021-06-09)
	animatecsshelp_speed integer,				--アニメーション速度(2021-06-09)
	animatecsshelp_delay integer,				--アニメーション遅延(2021-06-09)
	animatecsshelp_timing integer,				--アニメーション動作位置オフセット(2021-06-09)
	primary key (pageu_code)
);

--詳細データ格納テーブル（下書き情報）
CREATE TABLE extunit_instatl_tmp (
	pageu_code			integer,				--ユニット配列順序における登録番号
	dispflg				integer default 10,		--表示件数
	bg_color			smallint default 0,		--背景色　0：なし　1：あり
	bdr_type			smallint default 0,		--囲み線　0：なし　1：実線　2：点線
	btm_padding			smallint default 2,		--下部余白　0:なし　1：狭　2：標準　3：広
	link_type			smallint default 0,		--リンク先　0:投稿　1：ユーザー
	align_type			smallint default 0,		--寄せ方向　現在未使用
	access_token		text,					--facebook api アクセストークン
	insta_id			text,					--Instagram Business ID
	extra_class			text,					--ユーザー追加クラス(2021-06-09)
	anchor_text			text,					--アンカーテキスト(2021-06-09)
	animatecsshelp		text,					--アニメーションクラス(2021-06-09)
	animatecsshelp_speed integer,				--アニメーション速度(2021-06-09)
	animatecsshelp_delay integer,				--アニメーション遅延(2021-06-09)
	animatecsshelp_timing integer,				--アニメーション動作位置オフセット(2021-06-09)
	primary key (pageu_code)
);
 */
class extInstaTl extends unitCommon
{
	//------ ユニット毎に必ず設定しなくてはならない変数 -------//
	var $_table = "extunit_instatl"; //公開用テーブル名
	var $_tmptable = "extunit_instatl_tmp"; //下書き用テーブル名 //必ず公開用テーブル名のうしろに_tmpをつけてください
	var $columns = array(
					array("column"=>"pageu_code","conv"=>"n","tags"=>false),	//ユニット登録コード
					array("column"=>"img_num","conv"=>"n","tags"=>false),		//件数
					array("column"=>"bg_color","conv"=>"n","tags"=>false),		//背景色
					array("column"=>"bdr_type","conv"=>"n","tags"=>false),		//枠線
					array("column"=>"btm_padding","conv"=>"n","tags"=>false),	//下方スペース
					array("column"=>"link_type","conv"=>"n","tags"=>false),		//リンク先
					array("column"=>"insta_id","conv"=>"n","tags"=>false),		//instagram business id
					array("column"=>"access_token","conv"=>"n","tags"=>false),	//アクセストークン
					array("column"=>"json","conv"=>"n","tags"=>false),	//json
					array("column"=>"json_date","conv"=>"n","tags"=>false),	//json保存時刻
					array("column"=>"insta_row_pc","conv"=>"n","tags"=>false),	//json
					array("column"=>"insta_row_sp","conv"=>"n","tags"=>false),	//json保存時刻
					array("column"=>"extra_class","conv"=>"n","tags"=>false),	//ユーザークラス(2021-06-09)
					//アニメーション(2021-06-09)
					array("column"=>"animatecsshelp", "conv" => "KVa", "tags" => false),
					array("column"=>"animatecsshelp_speed", "conv" => "n", "tags" => false),
					array("column"=>"animatecsshelp_delay", "conv" => "n", "tags" => false),
					array("column"=>"animatecsshelp_timing", "conv" => "n", "tags" => false),
					);


	function extInstaTl()
	{
		$this->__construct();
	}

	function __construct()
	{
		unitCommon::__construct();
	}
	//-----------------

	//出力データセット処理（必須）
	function setDisplayData() {
		//2010.11.09
		if($this->_prev) {
			$this->_view->assign("prev",1);
		}
		$data = null;
		$admin = 0;
		$data = $this->getDetail();

		if(!is_array($data) || empty($data)){
			return array();
		}

		//管理画面フラグ 2021-02
		if(strpos($_SERVER['REQUEST_URI'],"/admin/contents/")!==FALSE){
			$this->_view->assign("admin",1);
			$admin = 1;
		}
		if(strpos($this->_view->_tpl_vars["SCRIPT_NAME"],"/admin/contents/")!==FALSE||strpos($this->_view->_tpl_vars["SCRIPT_NAME"],"/admin/aj/")!==FALSE){
			$this->_view->assign("admin",1);
			$admin = 1;
		}
		//管理画面フラグ 2021-02
		//insta取得 2021-02-25
		if(is_array($data) && !empty($data)){
			$data["images"] = $this->getInsta($data["access_token"],$data["insta_id"],$data["img_num"],10);
		}
		//insta取得 2021-02-25
		if($this->checkSP()){
			$this->_view->assign("instaRows",$data["insta_row_sp"]);
		}else{
			$this->_view->assign("instaRows",$data["insta_row_pc"]);
		}

		//2021-06-09 アニメーション反映
		if ($data['animatecsshelp']!="") {
			$data['extra_class'] .= " attach_anim attach_".$data['animatecsshelp'];
		}

		$unitStyle = $this->createUnitStyle($data);
            if (0 < count($unitStyle)) {
                $data['unitStyle'] = implode(' ', $unitStyle);
            }
		if (version_compare(BINGO_VERSION, '1.7.3', '>=')) {
			$data['unitAttr']=array('style'=>array());
			if ($data['animatecsshelp']!="" && preg_match('/.+Out.*/', $data['animatecsshelp'])) {
				$data['unitAttr']['style'][] = "visibility: visible;";
			}
			if ($data['animatecsshelp_speed']!="" && is_numeric($data['animatecsshelp_speed'])) {
				$data['unitAttr']['style'][] = "animation-duration: ".$data['animatecsshelp_speed']."ms;";
			}
			if ($data['animatecsshelp_delay']!="" && is_numeric($data['animatecsshelp_delay'])) {
				$data['unitAttr']['style'][] = "animation-delay: ".$data['animatecsshelp_delay']."ms;";
			}
			if ($data['animatecsshelp_timing']!="" && is_numeric($data['animatecsshelp_timing'])) {
				$data['unitAttr']['data-offset'][] = $data['animatecsshelp_timing'];
			}
		}
		//2021-06-09 アニメーション反映
		return $data;
	}

	/*
	 * DBより保存データ取得
	 * 改変可能
	 */
	function getDetail() {
		$rtn = null;
		$sql = "select * from ".$this->getTbl()." where pageu_code = ?";
		if(isset($this->_pageu_code)&&is_numeric($this->_pageu_code)) {
			$result = $this->db->prepare($sql,$this->_pageu_code);
			if($result) {
				$rtn = $result->fetchRow(DB_FETCHMODE_ASSOC);
			}
		}
		return $rtn;
	}

	//instagram画像取得 2021-02
	/**
	 * instagram画像取得
	 * @param string $token インスタグラムトークン
	 * @param string $insta_id インスタグラムビジネスID
	 * @param int $itemnum 取得枚数
	 * @param int $minute 情報更新までの時間（分）
	 */
	function getInsta($token,$insta_id,$itemnum=12,$minute=10){
		$api = "https://graph.facebook.com/"; //facebook api
		$apiver = "v10.0"; //facebook apiバージョン
		$field = "media.limit(".$itemnum."){caption,media_url,permalink,thumbnail_url,timestamp,username}"; //取得フィールド

		$url = $api.$apiver."/".$insta_id."?fields=".$field."&access_token=".$token; //リクエストURL

		$ret = array();
		//json確認
		$jsdata = $this->getDetail();
		//保存時刻と比較用時刻
		$compdate = date("Y-m-d H:i:s",strtotime("-".$minute." minute"));
		if((!isset($jsdata["json"])||$jsdata["json"] == "")||($jsdata["json_date"]<$compdate)||(!isset($jsdata["json_date"])||$jsdata["json_date"] == "")){
			$list = file_get_contents($url,NULL,stream_context_create(["http"=>["ignore_errors"=>TRUE]]));
			$list_dec = json_decode($list,TRUE);
			$now = date("Y-m-d H:i:s");

			$js = array();
			$js["json"] = $list;
			$js["json_date"] = $now;

			if(!$this->db->update($this->getTbl(),$js, "pageu_code=".$this->_pageu_code)) {
				$this->db->query('ROLLBACK');
				return "・jsonデータの保存に失敗しました";
			}
		}else{
			$list = $jsdata["json"];
		}

		$list_dec = json_decode($list,TRUE);

		if(isset($list_dec["error"]) && $list_dec["error"] != ""){
			//エラーコードからメッセージを作成
			switch((int)$list_dec["error"]["code"]){
				case 102:
					switch((int)$list_dec["error"]["error_subcode"]){
						case 458:
							$list_dec["error"]["message-j"] = "ユーザーがログインしていません。";
						break;
						case 459:
							$list_dec["error"]["message-j"] = "利用者のチェックポイントが設定されています。再度ログインを行ってください。";
						break;
						case 460:
							$list_dec["error"]["message-j"] = "パスワードが変更されました。再度ログインを行ってください。";
						break;
						case 463:
							$list_dec["error"]["message-j"] = "ログインまたはアクセストークンが期限切れになりました。";
						break;
						case 464:
							$list_dec["error"]["message-j"] = "ユーザー情報が未確認です。再度ログインを行ってください。";
						break;
						case 467:
							$list_dec["error"]["message-j"] = "アクセストークンが無効または期限切れになりました。";
						break;
						case 492:
							$list_dec["error"]["message-j"] = "セッションが無効です。";
						break;

						default:
							$list_dec["error"]["message-j"] = "ログインまたはアクセストークンが存在していません。再度アクセストークンを確認してください。";
						break;
					}
				break;
				case 1:
					$list_dec["error"]["message-j"] = "APIに不明なエラーが発生しました。しばらく経ってからやり直してください。";
				break;
				case 2:
					$list_dec["error"]["message-j"] = "APIが停止しています。しばらく経ってからやり直してください。";
				break;
				case 3:
					$list_dec["error"]["message-j"] = "アクセス許可にエラーが発生しました。";
				break;
				case 4:
				case 17:
					$list_dec["error"]["message-j"] = "一時的なエラーが発生しました。しばらく経ってからやり直してください。";
				break;
				case 32:
					$list_dec["error"]["message-j"] = "アクセス数が上限に到達しました。しばらく経ってからやり直してください。";
				break;
				case 10:
				case (int)$list_dec["error"]["code"] >= 200 && (int)$list_dec["error"]["code"] < 300:
					$list_dec["error"]["message-j"] = "APIのアクセス許可が存在しませんでした。";
				break;
				case 100:
					$list_dec["error"]["message-j"] = "Instagram Business IDが無効または入力されていません。再度IDを確認してください。";
				break;
				case 190:
					$list_dec["error"]["message-j"] = "アクセストークンが有効期限切れまたは無効です。もう一度アクセストークンを確認してください。";
				break;
				case 341:
					$list_dec["error"]["message-j"] = "アプリケーションの上限に達しました。しばらく経ってからやり直してください。";
				break;
				case 368:
					$list_dec["error"]["message-j"] = "ポリシーに違反しているため、一時的にブロックされています。しばらく経ってからやり直してください。";
				break;
				case 506:
					$list_dec["error"]["message-j"] = "重複する投稿を連続して公開することはできません。投稿の内容を変更して、もう一度実行してください。";
				break;
				case 803:
					$list_dec["error"]["message-j"] = "無効なInstagram Business IDです。再度IDを確認してください。";
				break;
				case 1609005:
					$list_dec["error"]["message-j"] = "リンクからデータを取得中に問題が発生しました。URLを確認して、もう一度実行してください。";
				break;
				default:
					$list_dec["error"]["message-j"] = "不明なエラーが発生しました。";
				break;
			}
			//エラー時にエラーコードとメッセージを返す
			$ret["error"] = "ErrorCode - ".$list_dec["error"]["code"]." : ".$list_dec["error"]["message-j"];
		}else{
			//リンクとサムネイルを返す
			foreach($list_dec["media"]["data"] as $k => $v){
				$ret[$k]["thumb"] = ($v['thumbnail_url']) ? $v['thumbnail_url'] : $v['media_url'];
				$ret[$k]["mediaid"] = $v['id'];
				$ret[$k]["link"] = $v['permalink'];
				$ret[$k]["user"] = $v['username'];
				$ret[$k]["caption"] = $v['caption'];
				$ret[$k]["thumbnail_url"] = $v['thumbnail_url'];
				$ret[$k]["media_url"] = $v['media_url'];
			}
		}

		return $ret;

	}


	function setDefault()
	{
		$this->data = $this->getDetail();
		//2021-06-09 共通プロパティ用
		$this->data = $this->getProperty4device($this->data);
		//2021-06-09 共通プロパティ用
		if(!isset($this->data)||$this->data==""){
			$this->data["img_num"] = 12;
			$this->data["link_type"] = 0;
			$this->data['insta_row_pc'] = 6;
			$this->data['insta_row_sp'] = 2;
		}
		$this->_form->setDefaults($this->data);

	}

	//フォームエレメントの作成
	function setElements()
	{
		$this->_form->addElement('hidden','pageu_code', $this->_pageu_code,array("id"=>"pageu_code")); //ページコード
		$this->_form->addElement('text','img_num', "",array("id"=>"img_num")); //件数
		$item=array();
		$item[]=$this->_form->createElement('radio',null, null, "投稿", 0);
		$item[]=$this->_form->createElement('radio',null, null, "ユーザー", 1);
		$this->_form->addGroup($item,'link_type');

		$this->_form->addElement('text','insta_id', "",array("id"=>"insta_id")); //Instagram Business ID
		$this->_form->addElement('textarea','access_token', "",array("id"=>"access_token","style"=>"width:600px;height:100px;")); //長期アクセストークン
		$rows = array(1=>1,2=>2,3=>3,4=>4,5=>5,6=>6);
		$this->_form->addElement('select','insta_row_pc','',$rows);
		$this->_form->addElement('select','insta_row_sp','',$rows);

		//アニメーションプロパティ 2021-06-09
		if (isset($_POST['animatecsshelp_speed'])) {
            $this->data['animatecsshelp_speed'] = $_POST['animatecsshelp_speed'];
        }
        if (isset($_POST['animatecsshelp_delay'])) {
            $this->data['animatecsshelp_delay'] = $_POST['animatecsshelp_delay'];
        }
        if (isset($_POST['animatecsshelp_timing'])) {
            $this->data['animatecsshelp_timing'] = $_POST['animatecsshelp_timing'];
        }

        $this->_view->assign('data', $this->data);

	}

	//フォーム入力エラーチェックの設定
	function setRules()
	{
		$this->_form->applyFilter('__ALL__','trim');
		$this->_form->_submitValues = DataBase::ConvColumnVals($this->_form->_submitValues,$this->columns); //ルールに従った値変換、タグの除去
		$this->_form->setJsWarnings('下記の項目が不正です。','');
		$this->_form->addRule('pageu_code','・「ユニットコード」が不明です。コンテンツ管理よりやり直してください','required',null,$this->erchk);
		$this->_form->addRule('img_num','・表示件数は必須入力です。','required',null,$this->erchk);
		$this->_form->addRule('img_num','・表示件数は数字で入力してください。','numeric',null,$this->erchk);
		$this->_form->addRule('img_num','・表示件数は1件以上入力してください。','nonzero',null,$this->erchk);
		$this->_form->addRule('insta_id','・Instagram Business IDは必須入力です。','required',null,$this->erchk);
		$this->_form->addRule('access_token','・facebook api アクセストークンは必須入力です。','required',null,$this->erchk);

	}

	//データ下書き保存処理
	function doSave($post)
	{
		$bflash = '';
		//既存データがあるか確認（画像削除用にも使用）
		$old_data = $this->getDetail();
		$record = null;
		foreach($this->columns as $val) {
			if($post[$val["column"]]!=null){
				$record[$val["column"]] = $post[$val["column"]];
			} else {
				$record[$val["column"]] = null;
			}
		}
		//既存データがあるか確認
		$old_data = $this->getDetail();
		$this->db->query('BEGIN');

		//保存処理開始
		if(is_array($old_data)&& count($old_data)>0) {
			//更新
			if(!$this->db->update($this->getTbl(),$record, "pageu_code=".$record["pageu_code"])) {
				$this->db->query('ROLLBACK');
				return "・データの保存に失敗しました";
			}
		} else { //新規
			if(!$this->db->insert($this->getTbl(),$record)) {
				$this->db->query('ROLLBACK');
				return "・データの保存に失敗しました";
			}
		}

		$this->db->query('COMMIT');

		return null;
	}
}
?>
